/*************************************************************************
 *
 *
 *    (c) Copyright Olimex 2009
 *
 *    File name   : usb_otg_pintest.h
 *    Description : USB OTG pins Test
 *
 *    History :
 *    1. Date        : 16, November 2009
 *       Author      : Aleksandar Mitev
 *       Description : Create
 *
 **************************************************************************/

#include "includes.h"
#include "usb_otg_pintest.h"

int MIC2075_2YM_Flag=-1;    // SPP - this flag contains value depending on the type of the controller

void Dly100us(void *arg);

void usbOtgPinTestIni(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	RCC_APB2PeriphClockCmd(  RCC_APB2Periph_GPIOA | RCC_APB2Periph_GPIOD | RCC_APB2Periph_GPIOE, ENABLE);
        MIC2075_2YM_Flag = GPIO_ReadInputDataBit (GPIOD, GPIO_Pin_7);   // SPP
		
// PE15 is the usb fault input (a pull up resistor is connected externally)
/* Configure PE15 as input floating, max speed 50 MHz */
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_15;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOE, &GPIO_InitStructure);	

// PD7 is the usb power enable pin
/* Configure PD7 as output push pull, max speed 50 MHz */
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOD, &GPIO_InitStructure);
        
        // SPP +
        if (MIC2075_2YM_Flag)
	  GPIO_SetBits(GPIOD, GPIO_Pin_7); // disable power	
        else
	  GPIO_ResetBits(GPIOD, GPIO_Pin_7); // disable power	
        // SPP -

// PA10 is USB ID pin
/* Configure PA10 as pulled-up input, max speed 50 MHz */
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOA, &GPIO_InitStructure);	
	
}

int usbOtgPinTest(void)
{
	printf("\n\n\nTest of USB pins");
	printf("\nUSB tester configuration:");
	printf("\nPlease ensure that SMALL load is selected and ID jumper is CLOSED");
        // SPP +
        if (MIC2075_2YM_Flag)
  	  GPIO_ResetBits(GPIOD, GPIO_Pin_7); // enable power
        else
	  GPIO_SetBits(GPIOD, GPIO_Pin_7); // enable power
        // SPP -
	Dly100us((void *)5000);
	
	// ask the user to connect the USB tester with small load
	printf("\nPlease connect USB tester w\\ SMALL load");
	printf("\nPlease connect USB tester w\\ SMALL load");
	
	// wait for the ID pin to become LOW (means tester is connected)
	while( GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_10) )
		Dly100us((void *)1);
	
	// check overload input
	Dly100us((void *)10000);
	if( !GPIO_ReadInputDataBit(GPIOE, GPIO_Pin_15) ) {
		// that's bad overload is detected
		printf("\nERROR!!! Overload detected");
		printf("\nERROR!!! Overload detected");
                // SPP +
                if (MIC2075_2YM_Flag)
		  GPIO_SetBits(GPIOD, GPIO_Pin_7); // disable power	
                else
		  GPIO_ResetBits(GPIOD, GPIO_Pin_7); // disable power	
                // SPP -
		return -1;
	}
	else { // OK no overload
		printf("\nOK, NO overload detected!");
	}
		
	// select HEAVY load
	printf("\nPlease select HEAVY load!");

	// wait for the overload input to fall
	while( GPIO_ReadInputDataBit(GPIOE, GPIO_Pin_15) )
		Dly100us((void *)1);
	
	// success of heavy load (overload detected)
	printf("\nOK, overload detected!");
	
	printf("\nSUCCESS!!! All tests completed!");
	printf("\nSUCCESS!!! All tests completed!");
	printf("\nSUCCESS!!! All tests completed!");
	printf("\nSUCCESS!!! All tests completed!");
        
        // SPP +
        if (MIC2075_2YM_Flag)
          GPIO_SetBits(GPIOD, GPIO_Pin_7); // disable power	
        else
	  GPIO_ResetBits(GPIOD, GPIO_Pin_7); // disable power	
        // SPP -
	return 0;
}

